#include <Windows.h>
#include <tchar.h>

int _tmain(int argc, _TCHAR* argv[]);

#define _MAX_CMD_LINE_ARGS  128

TCHAR *_ppszArgv[_MAX_CMD_LINE_ARGS + 1];

int __cdecl _ConvertCommandLineToArgcArgv( void )
{
	int cbCmdLine;
	int argc;
	TCHAR *pszSysCmdLine, *pszCmdLine;

	_ppszArgv[0] = 0;

	pszSysCmdLine = GetCommandLine();
	cbCmdLine = lstrlen(pszSysCmdLine);

	pszCmdLine = (TCHAR *) HeapAlloc( GetProcessHeap(), 0, (cbCmdLine + 1) * sizeof (TCHAR));

	if (!pszCmdLine) return 0;

	lstrcpy(pszCmdLine, pszSysCmdLine);

	if ('"' == *pszCmdLine)   
	{                           
		pszCmdLine++;

		_ppszArgv[0] = pszCmdLine; 

		while (*pszCmdLine && (*pszCmdLine != '"'))
			pszCmdLine++;

		if (*pszCmdLine)      
			*pszCmdLine++ = 0;  
		else
			return 0;         
	}
	else    
	{
		_ppszArgv[0] = pszCmdLine;

		while (*pszCmdLine && (' ' != *pszCmdLine) && ('\t' != *pszCmdLine))
			pszCmdLine++;

		if (*pszCmdLine)
			*pszCmdLine++ = 0; 
	}

	argc = 1;

	while (1)
	{
		while (*pszCmdLine && (' ' == *pszCmdLine) || ('\t' == *pszCmdLine))
			pszCmdLine++;

		if (0 == *pszCmdLine) 
			return argc;

		if ('"' == *pszCmdLine)   
		{
			pszCmdLine++; 

			_ppszArgv[ argc++ ] = pszCmdLine;
			_ppszArgv[ argc ] = 0;

			while (*pszCmdLine && (*pszCmdLine != '"'))
				pszCmdLine++;

			if (0 == *pszCmdLine)
				return argc;

			if (*pszCmdLine) *pszCmdLine++ = 0;  
		}
		else                    
		{
			_ppszArgv[ argc++ ] = pszCmdLine;
			_ppszArgv[ argc ] = 0;

			while (*pszCmdLine && (' '!=*pszCmdLine) && ('\t'!=*pszCmdLine))
				pszCmdLine++;

			if (0 == *pszCmdLine)
				return argc;

			if (*pszCmdLine)
				*pszCmdLine++ = 0;  
		}

		if (argc >= (_MAX_CMD_LINE_ARGS))
			return argc;
	}
}

#ifdef UNICODE
extern "C" int WINAPI wmainCRTStartup(void)
#else
extern "C" void __cdecl mainCRTStartup(void)
#endif
{
	int mainret, argc;

	argc = _ConvertCommandLineToArgcArgv();

	mainret = _tmain(argc, _ppszArgv);

	ExitProcess(mainret);
}
